<?php
//**********************************************************
// project: Juno IDE for Php
// unit: mysql.xql
// author: Jan Krizek
// ---------------------------------------------------------
// Php script for connecting to MySQL database
// *********************************************************
// Copyright (c) 2002-03 Jan Krizek
// *********************************************************

// input params, send using method GET
//  $charset - charset of database
//  $username, $password, $connect - info for connecting to database
//  $query - sql script to execute, queries are separated by semicolon
//  $databases - if is "show" then return list of databases
//  $database - name of database to use, only if isn't set $databases
//  $tables - if is "show" then return list of tables
//  $table - name of table to show it's fields

  $charset = $_GET['charset'];
  if ($charset == '') {        // if charset isn't set, set default to ISO Latin 1 (8859-1)
    $charset = 'iso-8859-1';   // this will changed when php will support UTF-8
  }
  $connect = $_GET['connect'];
  $username = $_GET['username'];
  $password = $_GET['password'];
  $query = $_GET['query'];
  $databases = $_GET['databases'];
  $database = $_GET['database'];
  $tables = $_GET['tables'];
  $table = $_GET['table'];
  
  header( "Content-Type: text/xml" );
  echo "<?xml version=\"1.0\" encoding=\"$charset\"?>\n";

function ReturnSQLError()
{
  return mysql_errno() . " - " . mysql_error();
}

// function RunQuery
// @param $query - one sql query
// @param $index - index in array, not used but function array_walk require this param
function RunQuery( $query, $number )
{
  $query = stripslashes( $query ); // remove escape sequence
  if (trim($query) == '') return;  // ignore empty queries

  echo '<query>';
  echo '<text>' . htmlspecialchars($query) . '</text>';
  echo '<result>';
  $rs = @mysql_query($query);
  if ($rs) {
    echo 'OK';
  }
  else {
    echo ReturnSQLError();
  }
  echo '</result>';
  if ($rs) {
    echo '<set count="' . @mysql_num_rows($rs) . '">';
    while ($arr = @mysql_fetch_row($rs)) {
      echo '<row>';
      reset($arr);
      while ($field = each($arr)) {
        $field_name = htmlspecialchars(mysql_field_name($rs, $field[key]));
        echo '<field name="' . $field_name . '" id="'. $field[key] . '">' .
            htmlspecialchars($field[value]) . '</field>';
      }
      echo '</row>';
    }
    echo '</set>';
    echo '<affected>' . @mysql_affected_rows() . '</affected>';
  }
  echo '</query>';
}

function Connect($connect, $username, $password)
{
  echo '<connect>';
  $conn = @mysql_connect($connect, $username, $password);
  if ($conn) {
    echo 'OK';
  }
  else {
    echo ReturnSQLError();
  }
  echo '</connect>';
  return $conn;
}

function ShowDatabases()
{
  echo '<databases>';
  $rs = @mysql_list_dbs();
  if ($rs) {
    $i = 0;
    while ($i < @mysql_num_rows($rs)) {
      echo '<database>' . @mysql_tablename($rs, $i) . "</database>\n";
      $i++;
    }
  }
  echo '</databases>';
  return $rs;
}

function SelectDb($database)
{
  echo '<database name="' . $database . '">';
  $db = @mysql_select_db($database);
  if ($db) {
    echo 'OK';
  }
  else {
    echo ReturnSQLError();
  }
  echo '</database>';
  return $db;
}

function ShowTables($database)
{
  echo '<tables>';
  $rs = @mysql_list_tables($database);
  if ($rs) {
    $i = 0;
    while ($i < @mysql_num_rows($rs)) {
      echo '<table>' . @mysql_tablename($rs, $i) . '</table>';
      $i++;
    }
  }
  echo '</tables>';
  return $rs;
}

function ShowFields($database, $table)
{
  echo '<table name="' . $table . '">';
  $rs = @mysql_list_fields($database, $table);
  if ($rs) {
    $i = 0;
    while ($i < @mysql_num_fields($rs)) {
      echo '<field type="' . @mysql_field_type($rs, $i) . '"';
      if (@mysql_field_type($rs, $i) == 'string') { // size only for string fields
        echo ' len="' .  @mysql_field_len($rs, $i). '"';
      }
      echo '>'. @mysql_field_name($rs, $i) . '</field>';
      $i++;
    }
  }
  echo "  </table>\n";
  return $rs;
}

  echo '<sql>';
  $conn = Connect($connect, $username, $password);
  if ($conn) {
    if ($databases == 'show') {
      ShowDatabases();
    }
    else {
      if (SelectDb($database)) {
        if ($query != '') {
          $queries = explode(';', $query);
          array_walk($queries, RunQuery);
        }
        if ($tables == 'show') {
          ShowTables($database);
        }
        if ($table != '') {
          ShowFields($database, $table);
        }
      }
    }
  }
  echo '</sql>';
?>
